--- main/sched.c.orig	2013-08-23 08:28:46.000000000 +0300
+++ main/sched.c	2013-08-23 08:30:36.000000000 +0300
@@ -333,7 +333,7 @@
  */
 int ast_sched_wait(struct sched_context *con)
 {
-	int ms;
+	int64_t ms;
 	struct sched *s;
 
 	DEBUG(ast_debug(1, "ast_sched_wait()\n"));
@@ -341,7 +341,9 @@
 	ast_mutex_lock(&con->lock);
 	if ((s = ast_heap_peek(con->sched_heap, 1))) {
 		ms = ast_tvdiff_ms(s->when, ast_tvnow());
-		if (ms < 0) {
+		if (ms > INT_MAX) {
+			ms = -1;
+		} else if (ms < 0) {
 			ms = 0;
 		}
 	} else {
